Subject: Re: [PATCH][RFC] Re: high latency with TCP connections

From: Rick Jones <[email-masked]>
Date: Tue, 05 Sep 2006 10:55:16 -0700

Alexey Kuznetsov wrote:
> Hello!
> 
> 
>>Some people reported that this program runs in 9.997 sec when run on
>>FreeBSD.
> 
> 
> Try enclosed patch. I have no idea why 9.997 sec is so magic, but I
> get exactly this number on my notebook. :-)
> 
> Alexey
> 
> =================
> 
> This patch enables sending ACKs each 2d received segment.
> It does not affect either mss-sized connections (obviously) or connections
> controlled by Nagle (because there is only one small segment in flight).
> 
> The idea is to record the fact that a small segment arrives
> on a connection, where one small segment has already been received
> and still not-ACKed. In this case ACK is forced after tcp_recvmsg()
> drains receive buffer.
> 
> In other words, it is a "soft" each-2d-segment ACK, which is enough
> to preserve ACK clock even when ABC is enabled.

Is this really necessary?  I thought that the problems with ABC were in 
trying to apply byte-based heuristics from the RFC(s) to a 
packet-oritented cwnd in the stack?

rick jones